/* Copyright 2011 Fog Creek Software, Inc. */

using System;
using System.Collections.Generic;
using System.Text;
using System.Web;

/* FogBugz namespaces-- make sure you add the neccesary assembly references to
 * DLL files contained in C:\Program Files\FogBugz\website\bin\ */
using FogCreek.FogBugz;
using FogCreek.FogBugz.UI;
using FogCreek.FogBugz.Plugins;
using FogCreek.FogBugz.Plugins.Api;
using FogCreek.FogBugz.Plugins.Interfaces;

namespace IPluginJS_Example
{
    /* Class Declaration: Inherit from Plugin, implement IPluginJS */
    public class IPluginJS_Example : Plugin, IPluginJS, IPluginExtrasMenu
    {
        /* Constructor: We'll just initialize the inherited Plugin class, which 
         * takes the passed instance of CPluginApi and sets its "api" member variable. */
        public IPluginJS_Example(CPluginApi api): base(api)
        {
        }

        #region IPluginJS Members

        public CJSInfo JSInfo()
        {
            CJSInfo jsinfo = new CJSInfo();
            /* This file name is relative to the plugin's /static/ folder. */
            jsinfo.rgsStaticFiles = new string[] { "js/custom_message.js" };

            /* sInlineJS must be generated when JSInfo() is called. It can have dynamic content. */
            jsinfo.sInlineJS = "var IPluginJS_Example_pluginPrefix = \"" + base.api.PluginPrefix + "\";";

            return jsinfo;
        }

        #endregion

        #region IPluginExtrasMenu Members

        public CNavMenuLink[] ExtrasMenuLinks()
        {
            /* this menu link is added for all logged in users */
            return new CNavMenuLink[]{new CNavMenuLink("Say Hello with Javascript!", 
                "javascript:insertCustomHeader('Hello, Kiwi!');")};
        }

        #endregion

    }
}